<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>
                </ion-buttons>
                <ion-title>Uživatelé</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>

            <p>Pro editaci 2x klikněte na pole.</p>

            <grid-wrapper :options="gridOptions" :rowData="rowData">
            </grid-wrapper>
        </ion-content>

        <device-modal
            :is-open="deviceModalShow"
            :user-id="deviceModalUserId"
            @closeModal="() => (deviceModalShow = false)"
        ></device-modal>
        <group-modal
            :is-open="groupModalShow"
            :user-id="groupModalUserId"
            @closeModal="() => (groupModalShow = false)"
        ></group-modal>
    </ion-page>
</template>

<script setup lang="ts">
import {
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonButtons,
} from '@ionic/vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed, ref, watch } from 'vue'
import { useGlobalStore } from '@/stores/globalStore'
import { AppUser, AppUserEdge, App_User_State } from '@/gql/graphql'
import toast from '@/helpers/toast'
import GridButtonDelete from '@/component/Grid/GridButtonDelete.vue'
import GridButtonAdd from '@/component/Grid/GridButtonAdd.vue'
import GridButtonDeviceModal from '@/component/Device/GridButtonDeviceModal.vue'

import 'ag-grid-community/styles/ag-grid.css'
import 'ag-grid-community/styles/ag-theme-quartz.css'
import {
    stateList,
    traslateState,
    untraslateState,
} from '@/helpers/appUserStateTranslator'
import DeviceModal from '@/component/Device/DeviceModal.vue'
import GroupModal from '@/component/Group/GroupModal.vue'
import GridButtonGroupModal from '@/component/Group/GridButtonGroupModal.vue'
import {
    GridOptions,
    RowClickedEvent,
    CellEditRequestEvent,
} from 'ag-grid-community'
import GridWrapper from '@/component/Grid/GridWrapper.vue'

// Queries
const { mutate: updateAppUser } = useMutation(gql`
    mutation updateAppUser($id: ID!, $data: updateAppUser!) {
        updateAppUser(id: $id, appUser: $data) {
            id
            username
            name
            isAdmin
            state
            roles
            lastLoginAt
            createdAt
            updatedAt
            deviceList {
                id
            }
            deviceGroupList {
                id
            }
        }
    }
`)

const { mutate: removeAppUser } = useMutation(gql`
    mutation removeAppUser($id: ID!) {
        removeAppUser(id: $id)
    }
`)

const { mutate: createAppUser } = useMutation(gql`
    mutation createAppUser($data: createAppUser!) {
        createAppUser(appUser: $data) {
            id
            username
            name
            isAdmin
            state
            roles
            lastLoginAt
            createdAt
            updatedAt
            deviceList {
                id
            }
            deviceGroupList {
                id
            }
        }
    }
`)

const { loading, result, refetch } = useQuery(
    gql`
        query appUserList {
            appUserList(first: 10000) {
                edges {
                    node {
                        id
                        username
                        name
                        isAdmin
                        state
                        roles
                        lastLoginAt
                        createdAt
                        updatedAt
                        deviceList {
                            id
                        }
                        deviceGroupList {
                            id
                        }
                    }
                }
            }
        }
    `,
    null,
    { fetchPolicy: 'network-only' }
)

const rowData = computed(() =>
    result?.value?.appUserList?.edges?.map((item: AppUserEdge) => item.node)
)

const defaultAddData = {
    id: 'Nový',
    username: '',
    name: '',
    isAdmin: false,
    state: App_User_State.NoAccess,
    roles: [],
    lastLoginAt: '-',
    createdAt: '-',
    updatedAt: '-',
    deviceGroupList: [],
    deviceList: [],
}

// Grid
const onCellEditRequest = (event: CellEditRequestEvent<AppUser>) => {
    // Zpět z přeloženého stavu
    if (event.colDef.field === 'state') {
        event.newValue = untraslateState(event.newValue)
    }

    // Požadavek na přidání nového, aktualizovat data v gridu
    if (!Number(event.data?.id)) {
        event.node.setData({
            ...event.data, // Nechat původní data
            [event.colDef.field as string]: event.newValue,
        })
        return
    }

    updateAppUser({
        id: event.data.id,
        data: {
            [event.colDef.field as string]: event.newValue,
        },
    }).then(() => {
        toast(
            'Pole ' + event.colDef.headerName + ' změněno z ' + event.oldValue,
            'success'
        )
    })
}

const onDeleteClick = (cellClicked: RowClickedEvent<AppUser>) => {
    removeAppUser({ id: cellClicked.data?.id }).then(() => {
        refetch()
        toast(cellClicked.data?.name + ' smazáno', 'success')
    })
}

const onAddClick = (cellClicked: RowClickedEvent<AppUser>) => {
    if (!cellClicked.data) {
        return
    }

    const data = (({ username, name, isAdmin, state }) => ({
        username,
        name,
        isAdmin,
        state,
    }))(cellClicked.data)

    createAppUser({ data }).then(() => {
        refetch()
        cellClicked.node.setData(defaultAddData)
        toast(data.name + ' přidáno', 'success')
    })
}

const deviceModalShow = ref(false)
const deviceModalUserId = ref('')

const groupModalShow = ref(false)
const groupModalUserId = ref('')

const onDeviceModalShow = (cellClicked: RowClickedEvent<AppUser>) => {
    if (!cellClicked.data?.id) {
        return
    }

    deviceModalUserId.value = cellClicked.data.id
    deviceModalShow.value = true
}

const onGroupModalShow = (cellClicked: RowClickedEvent<AppUser>) => {
    if (!cellClicked.data?.id) {
        return
    }

    groupModalUserId.value = cellClicked.data.id
    groupModalShow.value = true
}

const gridOptions: GridOptions<AppUser> = {
    onCellEditRequest: onCellEditRequest,
    pagination: true,
    pinnedTopRowData: [defaultAddData],
    columnDefs: [
        { field: 'id', headerName: 'id', width: 80, pinned: 'left' },
        {
            field: 'username',
            headerName: 'Uživatelské jméno',
            cellClass: 'bold',
            editable: true,
        },
        {
            field: 'name',
            headerName: 'Celé jméno uživatele',
            editable: true,
        },
        {
            field: 'isAdmin',
            headerName: 'Admin',
            width: 80,
            editable: true,
        },
        {
            field: 'state',
            headerName: 'Přístup',
            cellEditor: 'agSelectCellEditor',
            cellEditorParams: {
                values: stateList,
            },
            width: 160,
            editable: true,
            valueFormatter: (val) => traslateState(val.value),
        },
        {
            field: 'lastLoginAt',
            headerName: 'Poslední přihlášení',
            type: 'date',
        },
        { field: 'createdAt', headerName: 'Založen', type: 'date' },
        { field: 'updatedAt', headerName: 'Poslední update', type: 'date' },
        {
            headerName: 'Akce',
            width: 80,
            filter: false,
            sortable: false,
            cellRendererSelector: (params) => {
                if (Number(params.data?.id)) {
                    return {
                        component: GridButtonDelete,
                        params: { onClick: onDeleteClick },
                    }
                }
                return {
                    component: GridButtonAdd,
                    params: { onClick: onAddClick },
                }
            },
        },
        {
            width: 100,
            filter: false,
            sortable: false,
            headerName: 'Zařízení',
            cellRendererSelector: (params) => {
                if (
                    Number(params.data?.id) &&
                    params?.data?.deviceList?.length !== 0
                ) {
                    return {
                        component: GridButtonDeviceModal,
                        params: { onClick: onDeviceModalShow },
                    }
                }
            },
        },
        {
            width: 100,
            filter: false,
            sortable: false,
            headerName: 'Skupiny',
            cellRendererSelector: (params) => {
                if (
                    Number(params.data?.id) &&
                    params?.data?.deviceGroupList?.length !== 0
                ) {
                    return {
                        component: GridButtonGroupModal,
                        params: { onClick: onGroupModalShow },
                    }
                }
            },
        },
    ],
}

// Dark mode
const globalStore = useGlobalStore()

const theme = ref(
    globalStore.darkMode ? 'ag-theme-quartz-dark' : 'ag-theme-quartz'
)
watch(
    globalStore,
    (val) =>
        (theme.value = val.darkMode
            ? 'ag-theme-quartz-dark'
            : 'ag-theme-quartz')
)
</script>

<style>
.bold {
    font-weight: bold;
}
</style>
